Index: /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/ice.F90
===================================================================
--- /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/ice.F90	(revision 8505)
+++ /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/ice.F90	(revision 8506)
@@ -176,20 +176,4 @@
    INTEGER , PUBLIC ::   jiceprt          !: debug j-point
 
-   !                                     !!** ice-init namelist (namiceini) **
-                                          ! -- iceist -- !
-   LOGICAL , PUBLIC ::   ln_limini        ! initialization or not
-   LOGICAL , PUBLIC ::   ln_limini_file   ! Ice initialization state from 2D netcdf file
-   REAL(wp), PUBLIC ::   rn_thres_sst     ! threshold water temperature for initial sea ice
-   REAL(wp), PUBLIC ::   rn_hts_ini_n     ! initial snow thickness in the north
-   REAL(wp), PUBLIC ::   rn_hts_ini_s     ! initial snow thickness in the south
-   REAL(wp), PUBLIC ::   rn_hti_ini_n     ! initial ice thickness in the north
-   REAL(wp), PUBLIC ::   rn_hti_ini_s     ! initial ice thickness in the south
-   REAL(wp), PUBLIC ::   rn_ati_ini_n     ! initial leads area in the north
-   REAL(wp), PUBLIC ::   rn_ati_ini_s     ! initial leads area in the south
-   REAL(wp), PUBLIC ::   rn_smi_ini_n     ! initial salinity 
-   REAL(wp), PUBLIC ::   rn_smi_ini_s     ! initial salinity
-   REAL(wp), PUBLIC ::   rn_tmi_ini_n     ! initial temperature
-   REAL(wp), PUBLIC ::   rn_tmi_ini_s     ! initial temperature
-   
    !                                     !!** ice-dynamics namelist (namicedyn) **
                                           ! -- iceadv -- !
@@ -252,20 +236,4 @@
    REAL(wp), PUBLIC ::   rn_simin         !: minimum ice salinity [PSU]
 
-   !                                     !!** ice-mechanical redistribution namelist (namiceitdme)
-   REAL(wp), PUBLIC ::   rn_cs            !: fraction of shearing energy contributing to ridging            
-   INTEGER , PUBLIC ::   nn_partfun       !: participation function: =0 Thorndike et al. (1975), =1 Lipscomb et al. (2007)
-   REAL(wp), PUBLIC ::   rn_gstar         !: fractional area of young ice contributing to ridging
-   REAL(wp), PUBLIC ::   rn_astar         !: equivalent of G* for an exponential participation function
-   LOGICAL , PUBLIC ::   ln_ridging       !: ridging of ice or not                        
-   REAL(wp), PUBLIC ::   rn_hstar         !: thickness that determines the maximal thickness of ridged ice
-   REAL(wp), PUBLIC ::   rn_por_rdg       !: initial porosity of ridges (0.3 regular value)
-   REAL(wp), PUBLIC ::   rn_fsnowrdg      !: fractional snow loss to the ocean during ridging
-   REAL(wp), PUBLIC ::   rn_fpondrdg      !: fractional melt pond loss to the ocean during ridging
-   LOGICAL , PUBLIC ::   ln_rafting       !: rafting of ice or not                        
-   REAL(wp), PUBLIC ::   rn_hraft         !: threshold thickness (m) for rafting / ridging 
-   REAL(wp), PUBLIC ::   rn_craft         !: coefficient for smoothness of the hyperbolic tangent in rafting
-   REAL(wp), PUBLIC ::   rn_fsnowrft      !: fractional snow loss to the ocean during ridging
-   REAL(wp), PUBLIC ::   rn_fpondrft      !: fractional snow loss to the ocean during rafting
-
    ! MV MP 2016
    !                                     !!** melt pond namelist (namicemp)
Index: /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/iceist.F90
===================================================================
--- /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/iceist.F90	(revision 8505)
+++ /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/iceist.F90	(revision 8506)
@@ -46,4 +46,20 @@
    INTEGER , PARAMETER ::   jp_smi = 6           ! index of ice sali at T-point
    TYPE(FLD), ALLOCATABLE, DIMENSION(:) ::   si  ! structure of input fields (file informations, fields read)
+   !
+   ! ** namelist (namiceini) **
+   LOGICAL  ::   ln_limini        ! initialization or not
+   LOGICAL  ::   ln_limini_file   ! Ice initialization state from 2D netcdf file
+   REAL(wp) ::   rn_thres_sst     ! threshold water temperature for initial sea ice
+   REAL(wp) ::   rn_hts_ini_n     ! initial snow thickness in the north
+   REAL(wp) ::   rn_hts_ini_s     ! initial snow thickness in the south
+   REAL(wp) ::   rn_hti_ini_n     ! initial ice thickness in the north
+   REAL(wp) ::   rn_hti_ini_s     ! initial ice thickness in the south
+   REAL(wp) ::   rn_ati_ini_n     ! initial leads area in the north
+   REAL(wp) ::   rn_ati_ini_s     ! initial leads area in the south
+   REAL(wp) ::   rn_smi_ini_n     ! initial salinity 
+   REAL(wp) ::   rn_smi_ini_s     ! initial salinity
+   REAL(wp) ::   rn_tmi_ini_n     ! initial temperature
+   REAL(wp) ::   rn_tmi_ini_s     ! initial temperature
+   
    !!----------------------------------------------------------------------
    !! NEMO/ICE 4.0 , NEMO Consortium (2017)
Index: /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icerdgrft.F90
===================================================================
--- /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icerdgrft.F90	(revision 8505)
+++ /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icerdgrft.F90	(revision 8506)
@@ -36,7 +36,5 @@
    PUBLIC   ice_rdgrft_alloc         ! called by ice_init 
 
-   !-----------------------------------------------------------------------
    ! Variables shared among ridging subroutines
-   !-----------------------------------------------------------------------
    REAL(wp), ALLOCATABLE, DIMENSION(:,:)   ::   asum     ! sum of total ice and open water area
    REAL(wp), ALLOCATABLE, DIMENSION(:,:)   ::   aksum    ! ratio of area removed to area ridged
@@ -51,7 +49,21 @@
    REAL(wp), PARAMETER ::   krdgmin = 1.1_wp    ! min ridge thickness multiplier
    REAL(wp), PARAMETER ::   kraft   = 0.5_wp    ! rafting multipliyer
-   !
    REAL(wp)            ::   zdrho               ! 
    !
+   ! ** namelist (namiceitdme) **
+   REAL(wp) ::   rn_cs            !: fraction of shearing energy contributing to ridging            
+   INTEGER  ::   nn_partfun       !: participation function: =0 Thorndike et al. (1975), =1 Lipscomb et al. (2007)
+   REAL(wp) ::   rn_gstar         !: fractional area of young ice contributing to ridging
+   REAL(wp) ::   rn_astar         !: equivalent of G* for an exponential participation function
+   LOGICAL  ::   ln_ridging       !: ridging of ice or not                        
+   REAL(wp) ::   rn_hstar         !: thickness that determines the maximal thickness of ridged ice
+   REAL(wp) ::   rn_por_rdg       !: initial porosity of ridges (0.3 regular value)
+   REAL(wp) ::   rn_fsnowrdg      !: fractional snow loss to the ocean during ridging
+   REAL(wp) ::   rn_fpondrdg      !: fractional melt pond loss to the ocean during ridging
+   LOGICAL  ::   ln_rafting       !: rafting of ice or not                        
+   REAL(wp) ::   rn_hraft         !: threshold thickness (m) for rafting / ridging 
+   REAL(wp) ::   rn_craft         !: coefficient for smoothness of the hyperbolic tangent in rafting
+   REAL(wp) ::   rn_fsnowrft      !: fractional snow loss to the ocean during ridging
+   REAL(wp) ::   rn_fpondrft      !: fractional snow loss to the ocean during rafting
    !
    !!----------------------------------------------------------------------
Index: /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icethd.F90
===================================================================
--- /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icethd.F90	(revision 8505)
+++ /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icethd.F90	(revision 8506)
@@ -448,5 +448,5 @@
          END DO
          !
-         ! Change thickness to volume
+         ! Change thickness to volume (replaces routine ice_var_eqv2glo)
          v_i_1d(1:nidx)   = ht_i_1d(1:nidx) * a_i_1d(1:nidx)
          v_s_1d(1:nidx)   = ht_s_1d(1:nidx) * a_i_1d(1:nidx)