Index: trunk/NEMOGCM/CONFIG/GYRE_BFM/EXP00/namelist_cfg
===================================================================
--- trunk/NEMOGCM/CONFIG/GYRE_BFM/EXP00/namelist_cfg	(revision 8481)
+++ trunk/NEMOGCM/CONFIG/GYRE_BFM/EXP00/namelist_cfg	(revision 8508)
@@ -44,5 +44,5 @@
 !-----------------------------------------------------------------------
 &namcrs        !   Grid coarsening for dynamics output and/or
-               !   passive tracer coarsened online simulations
+!              !   passive tracer coarsened online simulations
 !-----------------------------------------------------------------------
 /
@@ -51,5 +51,5 @@
 !-----------------------------------------------------------------------
 !          ! file name ! frequency (hours)    ! variable ! time interp. ! clim  !'yearly' or ! weights  ! rotation !
-!          !           !  (if <0  months)     !   name   !  (logical)   ! (T/F) ! 'monthly'  ! filename ! pairing  
+!          !           !  (if <0  months)     !   name   !  (logical)   ! (T/F) ! 'monthly'  ! filename ! pairing
    cn_dir        = './'      !  root directory for the location of the runoff files
    ln_tsd_init   = .false.   !  Initialisation of ocean T & S with T &S input data (T) or not (F)
@@ -87,7 +87,4 @@
 &namsbc_ssr    !   surface boundary condition : sea surface restoring
 !-----------------------------------------------------------------------
-   nn_sssr     =     0     !  add a damping     term in the surface freshwater flux (=2)
-   rn_deds     =   -27.7   !  magnitude of the damping on salinity   [mm/day]
-   ln_sssr_bnd =   .false. !  flag to bound erp term (associated with nn_sssr=2)
 /
 !-----------------------------------------------------------------------
@@ -204,4 +201,8 @@
 !-----------------------------------------------------------------------
    ln_dynvor_ene = .true.  !  enstrophy conserving scheme
+   ln_dynvor_ens = .false. !  energy conserving scheme
+   ln_dynvor_mix = .false. !  mixed scheme
+   ln_dynvor_een = .false. !  energy & enstrophy scheme
+      nn_een_e3f = 1             !  e3f = masked averaging of e3t divided by 4 (=0) or by the sum of mask (=1)
 /
 !-----------------------------------------------------------------------
@@ -239,8 +240,4 @@
    rn_ahm_b      =      0.     !  background eddy viscosity for ldf_iso [m2/s]
    rn_bhm_0      =      0.     !  horizontal bilaplacian eddy viscosity [m4/s]
-   !
-   ! Caution in 20 and 30 cases the coefficient have to be given for a 1 degree grid (~111km)
-/
-   rn_ahm_0_lap     = 100000.   !  horizontal laplacian eddy viscosity   [m2/s]
 /
 !-----------------------------------------------------------------------
Index: trunk/NEMOGCM/CONFIG/GYRE_PISCES/EXP00/namelist_cfg
===================================================================
--- trunk/NEMOGCM/CONFIG/GYRE_PISCES/EXP00/namelist_cfg	(revision 8481)
+++ trunk/NEMOGCM/CONFIG/GYRE_PISCES/EXP00/namelist_cfg	(revision 8508)
@@ -31,5 +31,5 @@
       !                    !  (=F) user defined configuration  ==>>>  see usrdef(_...) modules
    ln_write_cfg= .false.   !  (=T) create the domain configuration file
-   !
+!
 /
 !-----------------------------------------------------------------------
@@ -60,5 +60,5 @@
 !-----------------------------------------------------------------------
    nn_fsbc     = 1         !  frequency of surface boundary condition computation
-   !                       !     (also = the frequency of sea-ice model call)
+                           !     (also = the frequency of sea-ice model call)
    ln_usr      = .true.    !  user defined formulation                  (T => check usrdef_sbc)
    ln_blk      = .false.   !  Bulk formulation                          (T => fill namsbc_blk )
@@ -240,8 +240,4 @@
    rn_ahm_b      =      0.     !  background eddy viscosity for ldf_iso [m2/s]
    rn_bhm_0      =      0.     !  horizontal bilaplacian eddy viscosity [m4/s]
-   !
-   ! Caution in 20 and 30 cases the coefficient have to be given for a 1 degree grid (~111km)
-/
-   rn_ahm_0_lap     = 100000.   !  horizontal laplacian eddy viscosity   [m2/s]
 /
 !-----------------------------------------------------------------------