Index: branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/iceist.F90
===================================================================
--- branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/iceist.F90	(revision 8506)
+++ branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/iceist.F90	(revision 8512)
@@ -47,7 +47,7 @@
    TYPE(FLD), ALLOCATABLE, DIMENSION(:) ::   si  ! structure of input fields (file informations, fields read)
    !
-   ! ** namelist (namiceini) **
-   LOGICAL  ::   ln_limini        ! initialization or not
-   LOGICAL  ::   ln_limini_file   ! Ice initialization state from 2D netcdf file
+   ! ** namelist (namice_ini) **
+   LOGICAL  ::   ln_iceini        ! initialization or not
+   LOGICAL  ::   ln_iceini_file   ! Ice initialization state from 2D netcdf file
    REAL(wp) ::   rn_thres_sst     ! threshold water temperature for initial sea ice
    REAL(wp) ::   rn_hts_ini_n     ! initial snow thickness in the north
@@ -126,7 +126,7 @@
       ! 2) Initialization of sea ice state variables
       !--------------------------------------------------------------------
-      IF( ln_limini ) THEN
+      IF( ln_iceini ) THEN
          !
-         IF( ln_limini_file )THEN
+         IF( ln_iceini_file )THEN
          !
             zht_i_ini(:,:)  = si(jp_hti)%fnow(:,:,1)
@@ -141,5 +141,5 @@
             END WHERE
             !
-         ELSE ! ln_limini_file = F
+         ELSE ! ln_iceini_file = F
 
             !--------------------------------------------------------------------
@@ -175,5 +175,5 @@
             END DO
             !
-         ENDIF ! ln_limini_file
+         ENDIF ! ln_iceini_file
          
          zvt_i_ini(:,:) = zht_i_ini(:,:) * zat_i_ini(:,:)   ! ice volume
@@ -403,5 +403,5 @@
          ! END MV MP 2016
 
-      ELSE ! if ln_limini=false
+      ELSE ! if ln_iceini=false
          a_i  (:,:,:) = 0._wp
          v_i  (:,:,:) = 0._wp
@@ -431,5 +431,5 @@
          h_ip     (:,:,:) = 0._wp
 
-      ENDIF ! ln_limini
+      ENDIF ! ln_iceini
       
       at_i (:,:) = 0.0_wp
@@ -518,9 +518,9 @@
       !! ** Purpose : Definition of initial state of the ice 
       !!
-      !! ** Method : Read the namiceini namelist and check the parameter 
+      !! ** Method : Read the namice_ini namelist and check the parameter 
       !!       values called at the first timestep (nit000)
       !!
       !! ** input : 
-      !!        Namelist namiceini
+      !!        Namelist namice_ini
       !!
       !! history :
@@ -537,5 +537,5 @@
       TYPE(FLD_N), DIMENSION(jpfldi) ::   slf_i                 ! array of namelist informations on the fields to read
       !
-      NAMELIST/namiceini/ ln_limini, ln_limini_file, rn_thres_sst, rn_hts_ini_n, rn_hts_ini_s,  &
+      NAMELIST/namice_ini/ ln_iceini, ln_iceini_file, rn_thres_sst, rn_hts_ini_n, rn_hts_ini_s,  &
          &                rn_hti_ini_n, rn_hti_ini_s, rn_ati_ini_n, rn_ati_ini_s, rn_smi_ini_n, &
          &                rn_smi_ini_s, rn_tmi_ini_n, rn_tmi_ini_s,                             &
@@ -543,12 +543,12 @@
       !!-----------------------------------------------------------------------------
       !
-      REWIND( numnam_ice_ref )              ! Namelist namiceini in reference namelist : Ice initial state
-      READ  ( numnam_ice_ref, namiceini, IOSTAT = ios, ERR = 901)
-901   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namiceini in reference namelist', lwp )
-
-      REWIND( numnam_ice_cfg )              ! Namelist namiceini in configuration namelist : Ice initial state
-      READ  ( numnam_ice_cfg, namiceini, IOSTAT = ios, ERR = 902 )
-902   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namiceini in configuration namelist', lwp )
-      IF(lwm) WRITE ( numoni, namiceini )
+      REWIND( numnam_ice_ref )              ! Namelist namice_ini in reference namelist : Ice initial state
+      READ  ( numnam_ice_ref, namice_ini, IOSTAT = ios, ERR = 901)
+901   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namice_ini in reference namelist', lwp )
+
+      REWIND( numnam_ice_cfg )              ! Namelist namice_ini in configuration namelist : Ice initial state
+      READ  ( numnam_ice_cfg, namice_ini, IOSTAT = ios, ERR = 902 )
+902   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namice_ini in configuration namelist', lwp )
+      IF(lwm) WRITE ( numoni, namice_ini )
 
       slf_i(jp_hti) = sn_hti  ;  slf_i(jp_hts) = sn_hts
@@ -563,7 +563,7 @@
          WRITE(numout,*) 'ice_ist_init : ice parameters inititialisation '
          WRITE(numout,*) '~~~~~~~~~~~~'
-         WRITE(numout,*) '   Namelist namiceini'
-         WRITE(numout,*) '      initialization with ice (T) or not (F)       ln_limini     = ', ln_limini
-         WRITE(numout,*) '      ice initialization from a netcdf file      ln_limini_file  = ', ln_limini_file
+         WRITE(numout,*) '   Namelist namice_ini'
+         WRITE(numout,*) '      initialization with ice (T) or not (F)       ln_iceini     = ', ln_iceini
+         WRITE(numout,*) '      ice initialization from a netcdf file      ln_iceini_file  = ', ln_iceini_file
          WRITE(numout,*) '      threshold water temp. for initial sea-ice    rn_thres_sst  = ', rn_thres_sst
          WRITE(numout,*) '      initial snow thickness in the north          rn_hts_ini_n  = ', rn_hts_ini_n
@@ -579,5 +579,5 @@
       ENDIF
 
-      IF( ln_limini_file ) THEN                      ! Ice initialization using input file
+      IF( ln_iceini_file ) THEN                      ! Ice initialization using input file
          !
          ! set si structure