Index: branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icerhg.F90
===================================================================
--- branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icerhg.F90	(revision 8514)
+++ branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icerhg.F90	(revision 8516)
@@ -20,5 +20,4 @@
    USE icerhg_evp     ! sea-ice: EVP rheology
    USE icectl         ! sea-ice: control prints
-   USE icevar         ! sea-ice: operations
    !
    USE lbclnk         ! lateral boundary conditions - MPP exchanges
@@ -55,5 +54,4 @@
       INTEGER, INTENT(in) ::   kt     ! ice time step
       !!
-      INTEGER  ::   jl   ! dummy loop indices
       REAL(wp) :: zvi_b, zsmv_b, zei_b, zfs_b, zfw_b, zft_b 
       !!--------------------------------------------------------------------
@@ -66,34 +64,13 @@
          WRITE(numout,*)'~~~~~~~'
       ENDIF
+      !                             ! -- conservation test
+      IF( ln_icediachk   )   CALL ice_cons_hsm(0, 'icerhg', zvi_b, zsmv_b, zei_b, zfw_b, zfs_b, zft_b)
 
-      CALL ice_var_agg(1)           ! -- aggregate ice categories
-      !
-      !                             ! -- conservation test
-      IF( ln_icediachk )   CALL ice_cons_hsm(0, 'icerhg', zvi_b, zsmv_b, zei_b, zfw_b, zfs_b, zft_b)
-      !                      
-      IF( ln_landfast ) THEN        ! -- Landfast ice parameterization: define max bottom friction
-         tau_icebfr(:,:) = 0._wp
-         DO jl = 1, jpl
-            WHERE( ht_i(:,:,jl) > ht_n(:,:) * rn_gamma )   tau_icebfr(:,:) = tau_icebfr(:,:) + a_i(:,:,jl) * rn_icebfr
-         END DO
-      ENDIF
-      
       ! -----------------------
       ! Rheology (ice dynamics)
       ! -----------------------   
-      IF( nn_icedyn /= 0 ) THEN     ! -- Ice dynamics
-         !
-         CALL ice_rhg_evp( kt, stress1_i, stress2_i, stress12_i, u_ice, v_ice, shear_i, divu_i, delta_i )
-         !
-      ELSE                          ! -- prescribed uniform velocity
-         !
-         u_ice(:,:) = rn_uice * umask(:,:,1)
-         v_ice(:,:) = rn_vice * vmask(:,:,1)
-         !!CALL RANDOM_NUMBER(u_ice(:,:))
-         !!CALL RANDOM_NUMBER(v_ice(:,:))
-         !
-      ENDIF
+      CALL ice_rhg_evp( kt, stress1_i, stress2_i, stress12_i, u_ice, v_ice, shear_i, divu_i, delta_i )
       !
-      !                                                   !- conservation test
+      !                             !- conservation test
       IF( ln_icediachk   )   CALL ice_cons_hsm(1, 'icerhg', zvi_b, zsmv_b, zei_b, zfw_b, zfs_b, zft_b)
       IF( ln_ctl         )   CALL ice_prt3D  ('icerhg')   !- Control prints
@@ -117,6 +94,5 @@
       INTEGER ::   ios   ! Local integer output status for namelist read
       !!
-      NAMELIST/namice_rhg/  rn_ishlat  , rn_cio   , rn_creepl, rn_ecc , nn_nevp, rn_relast,   &
-         &                ln_landfast, rn_gamma , rn_icebfr, rn_lfrelax
+      NAMELIST/namice_rhg/  ln_rhg_EVP, rn_creepl, rn_ecc , nn_nevp, rn_relast
       !!-------------------------------------------------------------------
       !
@@ -135,24 +111,10 @@
          WRITE(numout,*) '~~~~~~~~~~~~'
          WRITE(numout,*) '   Namelist namice_rhg'
-        WRITE(numout,*) '      rheology EVP (icerhg_evp)'
-         WRITE(numout,*) '         lateral boundary condition for sea ice dynamics          rn_ishlat     = ', rn_ishlat
-         WRITE(numout,*) '         drag coefficient for oceanic stress                      rn_cio        = ', rn_cio
+         WRITE(numout,*) '      rheology EVP (icerhg_evp)                                   ln_rhg_EVP    = ', ln_rhg_EVP
          WRITE(numout,*) '         creep limit                                              rn_creepl     = ', rn_creepl
          WRITE(numout,*) '         eccentricity of the elliptical yield curve               rn_ecc        = ', rn_ecc
          WRITE(numout,*) '         number of iterations for subcycling                      nn_nevp       = ', nn_nevp
          WRITE(numout,*) '         ratio of elastic timescale over ice time step            rn_relast     = ', rn_relast
-         WRITE(numout,*) '      Landfast: param (T or F)                                    ln_landfast   = ', ln_landfast
-         WRITE(numout,*) '         fraction of ocean depth that ice must reach              rn_gamma      = ', rn_gamma
-         WRITE(numout,*) '         maximum bottom stress per unit area of contact           rn_icebfr     = ', rn_icebfr
-         WRITE(numout,*) '         relax time scale (s-1) to reach static friction          rn_lfrelax    = ', rn_lfrelax
       ENDIF
-      !
-      IF     (      rn_ishlat == 0.                ) THEN   ;   IF(lwp) WRITE(numout,*) '   ===>>>   ice lateral  free-slip'
-      ELSEIF (      rn_ishlat == 2.                ) THEN   ;   IF(lwp) WRITE(numout,*) '   ===>>>   ice lateral  no-slip'
-      ELSEIF ( 0. < rn_ishlat .AND. rn_ishlat < 2. ) THEN   ;   IF(lwp) WRITE(numout,*) '   ===>>>   ice lateral  partial-slip'
-      ELSEIF ( 2. < rn_ishlat                      ) THEN   ;   IF(lwp) WRITE(numout,*) '   ===>>>   ice lateral  strong-slip'
-      ENDIF
-      !
-      IF( .NOT. ln_landfast )   tau_icebfr(:,:) = 0._wp     ! NO Landfast ice : set to zero one for all
       !
    END SUBROUTINE ice_rhg_init